Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34921)
@@ -474,23 +649,50 @@
     '12 3B 68 8D 3D 43 09 02' => 'Cosina AF Zoom 100-300mm F5.6-6.7 MC Macro',
 #
+    '12 38 69 97 35 42 09 02' => 'Promaster Spectrum 7 100-400mm F4.5-6.7',
+#
     '00 40 31 31 2C 2C 00 00' => 'Voigtlander Color Skopar 20mm F3.5 SLII Aspherical',
+    '00 48 3C 3C 24 24 00 00' => 'Voigtlander Color Skopar 28mm F2.8 SL II',
     '00 54 48 48 18 18 00 00' => 'Voigtlander Ultron 40mm F2 SLII Aspherical',
     '00 54 55 55 0C 0C 00 00' => 'Voigtlander Nokton 58mm F1.4 SLII',
     '00 40 64 64 2C 2C 00 00' => 'Voigtlander APO-Lanthar 90mm F3.5 SLII Close Focus',
 #
-    '00 40 2D 2D 2C 2C 00 00' => 'Carl Zeiss Distagon T* 3,5/18 ZF.2',
-    '00 48 32 32 24 24 00 00' => 'Carl Zeiss Distagon T* 2,8/21 ZF.2',
+    '00 40 2D 2D 2C 2C 00 00' => 'Carl Zeiss Distagon T* 3.5/18 ZF.2',
+    '00 48 27 27 24 24 00 00' => 'Carl Zeiss Distagon T* 2.8/15 ZF.2', #MykytaKozlov
+    '00 48 32 32 24 24 00 00' => 'Carl Zeiss Distagon T* 2.8/21 ZF.2',
+    '00 54 38 38 18 18 00 00' => 'Carl Zeiss Distagon T* 2/25 ZF.2',
     '00 54 3C 3C 18 18 00 00' => 'Carl Zeiss Distagon T* 2/28 ZF.2',
+    '00 54 44 44 0C 0C 00 00' => 'Carl Zeiss Distagon T* 1.4/35 ZF.2',
     '00 54 44 44 18 18 00 00' => 'Carl Zeiss Distagon T* 2/35 ZF.2',
-    '00 54 50 50 0C 0C 00 00' => 'Carl Zeiss Planar T* 1,4/50 ZF.2',
+    '00 54 50 50 0C 0C 00 00' => 'Carl Zeiss Planar T* 1.4/50 ZF.2',
     '00 54 50 50 18 18 00 00' => 'Carl Zeiss Makro-Planar T* 2/50 ZF.2',
-    '00 54 62 62 0C 0C 00 00' => 'Carl Zeiss Planar T* 1,4/85 ZF.2',
+    '00 54 62 62 0C 0C 00 00' => 'Carl Zeiss Planar T* 1.4/85 ZF.2',
     '00 54 68 68 18 18 00 00' => 'Carl Zeiss Makro-Planar T* 2/100 ZF.2',
+    '00 54 72 72 18 18 00 00' => 'Carl Zeiss Apo Sonnar T* 2/135 ZF.2',
+    '00 54 53 53 0C 0C 00 00' => 'Zeiss Otus 1.4/55', #IB
+    '01 54 62 62 0C 0C 00 00' => 'Zeiss Otus 1.4/85',
+    '03 54 68 68 0C 0C 00 00' => 'Zeiss Otus 1.4/100', #IB
+    '52 54 44 44 18 18 00 00' => 'Zeiss Milvus 35mm f/2',
+    '53 54 50 50 0C 0C 00 00' => 'Zeiss Milvus 50mm f/1.4', #IB
+    '54 54 50 50 18 18 00 00' => 'Zeiss Milvus 50mm f/2 Macro',
+    '55 54 62 62 0C 0C 00 00' => 'Zeiss Milvus 85mm f/1.4', #IB
+    '56 54 68 68 18 18 00 00' => 'Zeiss Milvus 100mm f/2 Macro',
 #
     '00 54 56 56 30 30 00 00' => 'Coastal Optical Systems 60mm 1:4 UV-VIS-IR Macro Apo',
 #
-    '4A 48 24 24 24 0C 4D 02' => 'Samyang AE 14mm f/2.8 ED AS IF UMC', #http://u88.n24.queensu.ca/exiftool/forum/index.php/topic,3150.0.html
+    'BF 4E 26 26 1E 1E 01 04' => 'Irix 15mm f/2.4 Firefly', #30
+    'BF 3C 1B 1B 30 30 01 04' => 'Irix 11mm f/4 Firefly', #30
+#
+    '4A 40 11 11 2C 0C 4D 02' => 'Samyang 8mm f/3.5 Fish-Eye CS',
+    '4A 48 24 24 24 0C 4D 02.1' => 'Samyang 10mm f/2.8 ED AS NCS CS',
+    '4A 48 1E 1E 24 0C 4D 02' => 'Samyang 12mm f/2.8 ED AS NCS Fish-Eye', #Jurgen Sahlberg
+    '4A 48 24 24 24 0C 4D 02.2' => 'Samyang AE 14mm f/2.8 ED AS IF UMC', #https://exiftool.org/forum/index.php/topic,3150.0.html
+    '4A 4C 24 24 1E 6C 4D 06' => 'Samyang 14mm f/2.4 Premium',
+    '4A 54 29 29 18 0C 4D 02' => 'Samyang 16mm f/2.0 ED AS UMC CS', #Jon Bloom (by email)
+    '4A 60 36 36 0C 0C 4D 02' => 'Samyang 24mm f/1.4 ED AS UMC',
     '4A 60 44 44 0C 0C 4D 02' => 'Samyang 35mm f/1.4 AS UMC',
-    '4A 60 62 62 0C 0C 4D 02' => 'Samyang AE 85mm f/1.4 AS IF UMC', #http://u88.n24.queensu.ca/exiftool/forum/index.php/topic,2888.0.html
+    '4A 60 62 62 0C 0C 4D 02' => 'Samyang AE 85mm f/1.4 AS IF UMC', #https://exiftool.org/forum/index.php/topic,2888.0.html
+#
+    '9A 4C 50 50 14 14 9C 06' => 'Yongnuo YN50mm F1.8N',
+    '9F 48 48 48 24 24 A1 06' => 'Yongnuo YN40mm F2.8N', #30
 #
     '02 40 44 5C 2C 34 02 00' => 'Exakta AF 35-70mm 1:3.5-4.5 MC',
@@ -499,14 +701,29 @@
     '03 43 5C 81 35 35 02 00' => 'Soligor AF C/D Zoom UMCS 70-210mm 1:4.5',
     '12 4A 5C 81 31 3D 09 00' => 'Soligor AF C/D Auto Zoom+Macro 70-210mm 1:4-5.6 UMCS',
+    '12 36 69 97 35 42 09 00' => 'Soligor AF Zoom 100-400mm 1:4.5-6.7 MC',
 #
     '00 00 00 00 00 00 00 01' => 'Manual Lens No CPU',
 #
+    '00 00 48 48 53 53 00 01' => 'Loreo 40mm F11-22 3D Lens in a Cap 9005', #PH
     '00 47 10 10 24 24 00 00' => 'Fisheye Nikkor 8mm f/2.8 AiS',
-    '00 54 44 44 0C 0C 00 00' => 'Nikkor 35mm f/1.4 AiS',
+    '00 47 3C 3C 24 24 00 00' => 'Nikkor 28mm f/2.8 AiS', #35
+  # '00 54 44 44 0C 0C 00 00' => 'Nikkor 35mm f/1.4 AiS', comment out in favour of Zeiss with same ID because this lens is rare (requires CPU upgrade)
+    '00 57 50 50 14 14 00 00' => 'Nikkor 50mm f/1.8 AI', #35
     '00 48 50 50 18 18 00 00' => 'Nikkor H 50mm f/2',
-    '00 58 64 64 20 20 00 00' => 'Soligor C/D Macro MC 90mm f/2.5',
     '00 48 68 68 24 24 00 00' => 'Series E 100mm f/2.8',
     '00 4C 6A 6A 20 20 00 00' => 'Nikkor 105mm f/2.5 AiS',
     '00 48 80 80 30 30 00 00' => 'Nikkor 200mm f/4 AiS',
+    '00 40 11 11 2C 2C 00 00' => 'Samyang 8mm f/3.5 Fish-Eye',
+    '00 58 64 64 20 20 00 00' => 'Soligor C/D Macro MC 90mm f/2.5',
+    '4A 58 30 30 14 0C 4D 02' => 'Rokinon 20mm f/1.8 ED AS UMC', #30
+);
+
+# text encoding used in LocationInfo (ref PH)
+%nikonTextEncoding = (
+    0 => 'n/a',
+    1 => 'UTF8',
+    # UTF16 is a guess here: it could also be Unicode or JIS,
+    # but I chose UTF16 due to the similarity with the QuickTime stringEncoding
+    2 => 'UTF16',
 );
 
@@ -525,4 +742,6 @@
     '5 1' => '5.01 (SB-900)',
     '5 2' => '5.02 (SB-900)',
+    '6 1' => '6.01 (SB-700)', #https://exiftool.org/forum/index.php/topic,5034.0.html
+    '7 1' => '7.01 (SB-910)', #PH
     OTHER => sub {
         my ($val, $inv) = @_;
@@ -535,14 +754,14 @@
 # flash Guide Number (GN) distance settings (ref 28)
 my %flashGNDistance = (
-    0 => 0,         19 => '2.8 m',
-    1 => '0.1 m',   20 => '3.2 m',
-    2 => '0.2 m',   21 => '3.6 m',
-    3 => '0.3 m',   22 => '4.0 m',
-    4 => '0.4 m',   23 => '4.5 m',
-    5 => '0.5 m',   24 => '5.0 m',
-    6 => '0.6 m',   25 => '5.6 m',
-    7 => '0.7 m',   26 => '6.3 m',
-    8 => '0.8 m',   27 => '7.1 m',
-    9 => '0.9 m',   28 => '8.0 m',
+     0 => 0,        19 => '2.8 m',
+     1 => '0.1 m',  20 => '3.2 m',
+     2 => '0.2 m',  21 => '3.6 m',
+     3 => '0.3 m',  22 => '4.0 m',
+     4 => '0.4 m',  23 => '4.5 m',
+     5 => '0.5 m',  24 => '5.0 m',
+     6 => '0.6 m',  25 => '5.6 m',
+     7 => '0.7 m',  26 => '6.3 m',
+     8 => '0.8 m',  27 => '7.1 m',
+     9 => '0.9 m',  28 => '8.0 m',
     10 => '1.0 m',  29 => '9.0 m',
     11 => '1.1 m',  30 => '10.0 m',
@@ -554,4 +773,17 @@
     17 => '2.2 m',  36 => '20.0 m',
     18 => '2.5 m',  255 => 'n/a',
+);
+
+# flash color filter values (ref 28)
+my %flashColorFilter = (
+    0x00 => 'None',
+    1 => 'FL-GL1 or SZ-2FL Fluorescent', # (green) (SZ model ref PH)
+    2 => 'FL-GL2',
+    9 => 'TN-A1 or SZ-2TN Incandescent', # (orange) (SZ model ref PH)
+    10 => 'TN-A2',
+    65 => 'Red',
+    66 => 'Blue',
+    67 => 'Yellow',
+    68 => 'Amber',
 );
 
@@ -569,12 +801,12 @@
 
 my %retouchValues = ( #PH
-    0 => 'None',
-    3 => 'B & W',
-    4 => 'Sepia',
-    5 => 'Trim',
-    6 => 'Small Picture',
-    7 => 'D-Lighting',
-    8 => 'Red Eye',
-    9 => 'Cyanotype',
+     0 => 'None',
+     3 => 'B & W',
+     4 => 'Sepia',
+     5 => 'Trim',
+     6 => 'Small Picture',
+     7 => 'D-Lighting',
+     8 => 'Red Eye',
+     9 => 'Cyanotype',
     10 => 'Sky Light',
     11 => 'Warm Tone',
@@ -593,5 +825,225 @@
     30 => 'Color Outline',
     31 => 'Soft Filter',
+    32 => 'Resize', #31
     33 => 'Miniature Effect',
+    34 => 'Skin Softening', # (S9200)
+    35 => 'Selected Frame', #31 (frame exported from MOV)
+    37 => 'Color Sketch', #31
+    38 => 'Selective Color', # (S9200)
+    39 => 'Glamour', # (S3500)
+    40 => 'Drawing', # (S9200)
+    44 => 'Pop', # (S3500)
+    45 => 'Toy Camera Effect 1', # (S3500)
+    46 => 'Toy Camera Effect 2', # (S3500)
+    47 => 'Cross Process (red)', # (S3500)
+    48 => 'Cross Process (blue)', # (S3500)
+    49 => 'Cross Process (green)', # (S3500)
+    50 => 'Cross Process (yellow)', # (S3500)
+    51 => 'Super Vivid', # (S3500)
+    52 => 'High-contrast Monochrome', # (S3500)
+    53 => 'High Key', # (S3500)
+    54 => 'Low Key', # (S3500)
+);
+
+# AF point indices for models with 51 focus points, eg. D3 (ref JD/PH)
+#        A1  A2  A3  A4  A5  A6  A7  A8  A9
+#    B1  B2  B3  B4  B5  B6  B7  B8  B9  B10  B11
+#    C1  C2  C3  C4  C5  C6  C7  C8  C9  C10  C11
+#    D1  D2  D3  D4  D5  D6  D7  D8  D9  D10  D11
+#        E1  E2  E3  E4  E5  E6  E7  E8  E9
+my %afPoints51 = (
+     1 => 'C6', 11 => 'C5', 21 => 'C9', 31 => 'C11',41 => 'A2', 51 => 'D1',
+     2 => 'B6', 12 => 'B5', 22 => 'B9', 32 => 'B11',42 => 'D3',
+     3 => 'A5', 13 => 'A4', 23 => 'A8', 33 => 'D11',43 => 'E2',
+     4 => 'D6', 14 => 'D5', 24 => 'D9', 34 => 'C4', 44 => 'C2',
+     5 => 'E5', 15 => 'E4', 25 => 'E8', 35 => 'B4', 45 => 'B2',
+     6 => 'C7', 16 => 'C8', 26 => 'C10',36 => 'A3', 46 => 'A1',
+     7 => 'B7', 17 => 'B8', 27 => 'B10',37 => 'D4', 47 => 'D2',
+     8 => 'A6', 18 => 'A7', 28 => 'A9', 38 => 'E3', 48 => 'E1',
+     9 => 'D7', 19 => 'D8', 29 => 'D10',39 => 'C3', 49 => 'C1',
+    10 => 'E6', 20 => 'E7', 30 => 'E9', 40 => 'B3', 50 => 'B1',
+);
+
+# AF point indices for models with 39 focus points, eg. D7000 (ref 29)
+#                    A1  A2  A3
+#    B1  B2  B3  B4  B5  B6  B7  B8  B9  B10  B11
+#    C1  C2  C3  C4  C5  C6  C7  C8  C9  C10  C11
+#    D1  D2  D3  D4  D5  D6  D7  D8  D9  D10  D11
+#                    E1  E2  E3
+my %afPoints39 = (
+     1 => 'C6', 11 => 'C5', 21 => 'D9', 31 => 'C3',
+     2 => 'B6', 12 => 'B5', 22 => 'C10',32 => 'B3',
+     3 => 'A2', 13 => 'A1', 23 => 'B10',33 => 'D3',
+     4 => 'D6', 14 => 'D5', 24 => 'D10',34 => 'C2',
+     5 => 'E2', 15 => 'E1', 25 => 'C11',35 => 'B2',
+     6 => 'C7', 16 => 'C8', 26 => 'B11',36 => 'D2',
+     7 => 'B7', 17 => 'B8', 27 => 'D11',37 => 'C1',
+     8 => 'A3', 18 => 'D8', 28 => 'C4', 38 => 'B1',
+     9 => 'D7', 19 => 'C9', 29 => 'B4', 39 => 'D1',
+    10 => 'E3', 20 => 'B9', 30 => 'D4',
+);
+
+# AF point indices for models with 105 focus points, eg. D6 (ref 28)
+# - 7 rows (A-G) with 15 columns (1-15), center is D8
+my %afPoints105 = (
+     1 => 'D8',  28 => 'G7',  55 => 'F13', 82 => 'E4',
+     2 => 'C8',  29 => 'D6',  56 => 'G13', 83 => 'F4',
+     3 => 'B8',  30 => 'C6',  57 => 'D14', 84 => 'G4',
+     4 => 'A8',  31 => 'B6',  58 => 'C14', 85 => 'D3',
+     5 => 'E8',  32 => 'A6',  59 => 'B14', 86 => 'C3',
+     6 => 'F8',  33 => 'E6',  60 => 'A14', 87 => 'B3',
+     7 => 'G8',  34 => 'F6',  61 => 'E14', 88 => 'A3',
+     8 => 'D9',  35 => 'G6',  62 => 'F14', 89 => 'E3',
+     9 => 'C9',  36 => 'D11', 63 => 'G14', 90 => 'F3',
+    10 => 'B9',  37 => 'C11', 64 => 'D15', 91 => 'G3',
+    11 => 'A9',  38 => 'B11', 65 => 'C15', 92 => 'D2',
+    12 => 'E9',  39 => 'A11', 66 => 'B15', 93 => 'C2',
+    13 => 'F9',  40 => 'E11', 67 => 'A15', 94 => 'B2',
+    14 => 'G9',  41 => 'F11', 68 => 'E15', 95 => 'A2',
+    15 => 'D10', 42 => 'G11', 69 => 'F15', 96 => 'E2',
+    16 => 'C10', 43 => 'D12', 70 => 'G15', 97 => 'F2',
+    17 => 'B10', 44 => 'C12', 71 => 'D5',  98 => 'G2',
+    18 => 'A10', 45 => 'B12', 72 => 'C5',  99 => 'D1',
+    19 => 'E10', 46 => 'A12', 73 => 'B5', 100 => 'C1',
+    20 => 'F10', 47 => 'E12', 74 => 'A5', 101 => 'B1',
+    21 => 'G10', 48 => 'F12', 75 => 'E5', 102 => 'A1',
+    22 => 'D7',  49 => 'G12', 76 => 'F5', 103 => 'E1',
+    23 => 'C7',  50 => 'D13', 77 => 'G5', 104 => 'F1',
+    24 => 'B7',  51 => 'C13', 78 => 'D4', 105 => 'G1',
+    25 => 'A7',  52 => 'B13', 79 => 'C4',
+    26 => 'E7',  53 => 'A13', 80 => 'B4',
+    27 => 'F7',  54 => 'E13', 81 => 'A4',
+);
+
+# AF point indices for models with 135 focus points, eg. 1J1 (ref PH)
+# - 9 rows (A-I) with 15 columns (1-15), center is E8
+# - odd columns, columns 2 and 14, and the remaining corner points are
+#   not used in 41-point mode
+my %afPoints135 = (
+     1 => 'E8', 28 => 'E10', 55 => 'E13',  82 => 'E6', 109 => 'E3',
+     2 => 'D8', 29 => 'D10', 56 => 'D13',  83 => 'D6', 110 => 'D3',
+     3 => 'C8', 30 => 'C10', 57 => 'C13',  84 => 'C6', 111 => 'C3',
+     4 => 'B8', 31 => 'B10', 58 => 'B13',  85 => 'B6', 112 => 'B3',
+     5 => 'A8', 32 => 'A10', 59 => 'A13',  86 => 'A6', 113 => 'A3',
+     6 => 'F8', 33 => 'F10', 60 => 'F13',  87 => 'F6', 114 => 'F3',
+     7 => 'G8', 34 => 'G10', 61 => 'G13',  88 => 'G6', 115 => 'G3',
+     8 => 'H8', 35 => 'H10', 62 => 'H13',  89 => 'H6', 116 => 'H3',
+     9 => 'I8', 36 => 'I10', 63 => 'I13',  90 => 'I6', 117 => 'I3',
+    10 => 'E9', 37 => 'E11', 64 => 'E14',  91 => 'E5', 118 => 'E2',
+    11 => 'D9', 38 => 'D11', 65 => 'D14',  92 => 'D5', 119 => 'D2',
+    12 => 'C9', 39 => 'C11', 66 => 'C14',  93 => 'C5', 120 => 'C2',
+    13 => 'B9', 40 => 'B11', 67 => 'B14',  94 => 'B5', 121 => 'B2',
+    14 => 'A9', 41 => 'A11', 68 => 'A14',  95 => 'A5', 122 => 'A2',
+    15 => 'F9', 42 => 'F11', 69 => 'F14',  96 => 'F5', 123 => 'F2',
+    16 => 'G9', 43 => 'G11', 70 => 'G14',  97 => 'G5', 124 => 'G2',
+    17 => 'H9', 44 => 'H11', 71 => 'H14',  98 => 'H5', 125 => 'H2',
+    18 => 'I9', 45 => 'I11', 72 => 'I14',  99 => 'I5', 126 => 'I2',
+    19 => 'E7', 46 => 'E12', 73 => 'E15', 100 => 'E4', 127 => 'E1',
+    20 => 'D7', 47 => 'D12', 74 => 'D15', 101 => 'D4', 128 => 'D1',
+    21 => 'C7', 48 => 'C12', 75 => 'C15', 102 => 'C4', 129 => 'C1',
+    22 => 'B7', 49 => 'B12', 76 => 'B15', 103 => 'B4', 130 => 'B1',
+    23 => 'A7', 50 => 'A12', 77 => 'A15', 104 => 'A4', 131 => 'A1',
+    24 => 'F7', 51 => 'F12', 78 => 'F15', 105 => 'F4', 132 => 'F1',
+    25 => 'G7', 52 => 'G12', 79 => 'G15', 106 => 'G4', 133 => 'G1',
+    26 => 'H7', 53 => 'H12', 80 => 'H15', 107 => 'H4', 134 => 'H1',
+    27 => 'I7', 54 => 'I12', 81 => 'I15', 108 => 'I4', 135 => 'I1',
+);
+
+# AF point indices for models with 153 focus points, eg. D5,D500 (ref PH)
+# - 9 rows (A-I) with 17 columns (1-17), center is E9
+# - 55 of these are selectable cross points (odd rows and columns 1,3,4,6,7,9,11,12,14,15,17)
+my %afPoints153 = (
+     1 => 'E9',  32 => 'A8',  63 => 'I13',  94 => 'B17', 125 => 'H4',
+     2 => 'D9',  33 => 'F8',  64 => 'E14',  95 => 'A17', 126 => 'I4',
+     3 => 'C9',  34 => 'G8',  65 => 'D14',  96 => 'F17', 127 => 'E3',
+     4 => 'B9',  35 => 'H8',  66 => 'C14',  97 => 'G17', 128 => 'D3',
+     5 => 'A9',  36 => 'I8',  67 => 'B14',  98 => 'H17', 129 => 'C3',
+     6 => 'F9',  37 => 'E7',  68 => 'A14',  99 => 'I17', 130 => 'B3',
+     7 => 'G9',  38 => 'D7',  69 => 'F14', 100 => 'E6',  131 => 'A3',
+     8 => 'H9',  39 => 'C7',  70 => 'G14', 101 => 'D6',  132 => 'F3',
+     9 => 'I9',  40 => 'B7',  71 => 'H14', 102 => 'C6',  133 => 'G3',
+    10 => 'E10', 41 => 'A7',  72 => 'I14', 103 => 'B6',  134 => 'H3',
+    11 => 'D10', 42 => 'F7',  73 => 'E15', 104 => 'A6',  135 => 'I3',
+    12 => 'C10', 43 => 'G7',  74 => 'D15', 105 => 'F6',  136 => 'E2',
+    13 => 'B10', 44 => 'H7',  75 => 'C15', 106 => 'G6',  137 => 'D2',
+    14 => 'A10', 45 => 'I7',  76 => 'B15', 107 => 'H6',  138 => 'C2',
+    15 => 'F10', 46 => 'E12', 77 => 'A15', 108 => 'I6',  139 => 'B2',
+    16 => 'G10', 47 => 'D12', 78 => 'F15', 109 => 'E5',  140 => 'A2',
+    17 => 'H10', 48 => 'C12', 79 => 'G15', 110 => 'D5',  141 => 'F2',
+    18 => 'I10', 49 => 'B12', 80 => 'H15', 111 => 'C5',  142 => 'G2',
+    19 => 'E11', 50 => 'A12', 81 => 'I15', 112 => 'B5',  143 => 'H2',
+    20 => 'D11', 51 => 'F12', 82 => 'E16', 113 => 'A5',  144 => 'I2',
+    21 => 'C11', 52 => 'G12', 83 => 'D16', 114 => 'F5',  145 => 'E1',
+    22 => 'B11', 53 => 'H12', 84 => 'C16', 115 => 'G5',  146 => 'D1',
+    23 => 'A11', 54 => 'I12', 85 => 'B16', 116 => 'H5',  147 => 'C1',
+    24 => 'F11', 55 => 'E13', 86 => 'A16', 117 => 'I5',  148 => 'B1',
+    25 => 'G11', 56 => 'D13', 87 => 'F16', 118 => 'E4',  149 => 'A1',
+    26 => 'H11', 57 => 'C13', 88 => 'G16', 119 => 'D4',  150 => 'F1',
+    27 => 'I11', 58 => 'B13', 89 => 'H16', 120 => 'C4',  151 => 'G1',
+    28 => 'E8',  59 => 'A13', 90 => 'I16', 121 => 'B4',  152 => 'H1',
+    29 => 'D8',  60 => 'F13', 91 => 'E17', 122 => 'A4',  153 => 'I1',
+    30 => 'C8',  61 => 'G13', 92 => 'D17', 123 => 'F4',
+    31 => 'B8',  62 => 'H13', 93 => 'C17', 124 => 'G4',
+);
+
+# AF point indices for models with 81 focus points, eg. Z6/Z7/Z50 (ref 38)
+# - 9 rows (A-I) with 9 columns (1-9), center is E5
+# NOTE: the AF points start 2 bytes into the data, so the map starts
+#       at 17 instead of 1
+#
+#        7   6   5   4   3   2   1   0
+# 00 : [H5][G5][F5][A5][B5][C5][D5][E5]
+# 01 : [G6][F6][A6][B6][C6][D6][E6][I5]
+# 02 : [F4][A4][B4][C4][D4][E4][I6][H6]
+# 03 : [A7][B7][C7][D7][E7][I4][H4][G4]
+# 04 : [B3][C3][D3][E3][I7][H7][G7][F7]
+# 05 : [C8][D8][E8][I3][H3][G3][F3][A3]
+# 06 : [D2][E2][I8][H8][G8][F8][A8][B8]
+# 07 : [E9][I2][H2][G2][F2][A2][B2][C2]
+# 08 : [I9][H9][G9][F9][A9][B9][C9][D9]
+# 09 : [H1][G1][F1][A1][B1][C1][D1][E1]
+# 0a : [  ][  ][  ][  ][  ][  ][  ][I1]
+my %afPoints81 = (
+     17 => 'E5',  34 => 'I6',  51 => 'H7',  68 => 'G8',  85 => 'F9',
+     18 => 'D5',  35 => 'E4',  52 => 'I7',  69 => 'H8',  86 => 'G9',
+     19 => 'C5',  36 => 'D4',  53 => 'E3',  70 => 'I8',  87 => 'H9',
+     20 => 'B5',  37 => 'C4',  54 => 'D3',  71 => 'E2',  88 => 'I9',
+     21 => 'A5',  38 => 'B4',  55 => 'C3',  72 => 'D2',  89 => 'E1',
+     22 => 'F5',  39 => 'A4',  56 => 'B3',  73 => 'C2',  90 => 'D1',
+     23 => 'G5',  40 => 'F4',  57 => 'A3',  74 => 'B2',  91 => 'C1',
+     24 => 'H5',  41 => 'G4',  58 => 'F3',  75 => 'A2',  92 => 'B1',
+     25 => 'I5',  42 => 'H4',  59 => 'G3',  76 => 'F2',  93 => 'A1',
+     26 => 'E6',  43 => 'I4',  60 => 'H3',  77 => 'G2',  94 => 'F1',
+     27 => 'D6',  44 => 'E7',  61 => 'I3',  78 => 'H2',  95 => 'G1',
+     28 => 'C6',  45 => 'D7',  62 => 'E8',  79 => 'I2',  96 => 'H1',
+     29 => 'B6',  46 => 'C7',  63 => 'D8',  80 => 'E9',  97 => 'I1',
+     30 => 'A6',  47 => 'B7',  64 => 'C8',  81 => 'D9',
+     31 => 'F6',  48 => 'A7',  65 => 'B8',  82 => 'C9',
+     32 => 'G6',  49 => 'F7',  66 => 'A8',  83 => 'B9',
+     33 => 'H6',  50 => 'G7',  67 => 'F8',  84 => 'A9',
+);
+
+my %cropHiSpeed = ( #IB
+    0 => 'Off',
+    1 => '1.3x Crop', # (1.3x Crop, Large)
+    2 => 'DX Crop', # (1.5x)
+    3 => '5:4 Crop',
+    4 => '3:2 Crop', # (1.2x, ref 36)
+    6 => '16:9 Crop',
+    8 => '2.7x Crop', #36 (D4/D500)
+    9 => 'DX Movie Crop', # (DX during movie recording, Large)
+    10 => '1.3x Movie Crop', #36 (D4/D500)
+    11 => 'FX Uncropped',
+    12 => 'DX Uncropped',
+    15 => '1.5x Movie Crop', #36 (D4/D500)
+    17 => '1:1 Crop',
+    OTHER => sub {
+        my ($val, $inv, $conv) = @_;
+        return undef if $inv;
+        my @a = split ' ', $val;
+        return "Unknown ($val)" unless @a == 7;
+        $a[0] = $$conv{$a[0]} || "Unknown ($a[0])";
+        return "$a[0] ($a[1]x$a[2] cropped to $a[3]x$a[4] at pixel $a[5],$a[6])";
+    },
 );
 
@@ -646,5 +1098,10 @@
     0x0005 => { Name => 'WhiteBalance', Writable => 'string' },
     0x0006 => { Name => 'Sharpness',    Writable => 'string' },
-    0x0007 => { Name => 'FocusMode',    Writable => 'string' },
+    0x0007 => {
+        Name => 'FocusMode',
+        DataMember => 'FocusMode',
+        Writable => 'string',
+        RawConv => '$$self{FocusMode} = $val',
+    },
     # FlashSetting (better named FlashSyncMode, ref 28) values:
     #   "Normal", "Slow", "Rear Slow", "RED-EYE", "RED-EYE SLOW"
@@ -656,6 +1113,6 @@
     #   no flash: ""
     0x0009 => { Name => 'FlashType',    Writable => 'string' }, #2 (count varies by model - PH)
-    # 0x000a - rational values: 5.6 to 9.283 - found in coolpix models - PH
-    #          (not correlated with any LV or scale factor)
+    # 0x000a - rational values: 5.6 to 9.33 - found in Coolpix models - PH
+    #          (seems constant for a given camera model, but not correlated with scale factor)
     0x000b => { #2
         Name => 'WhiteBalanceFineTune',
@@ -712,5 +1169,9 @@
         Writable => 'undef',
         Count => 4,
-        Notes => 'may be set even if flash does not fire',
+        # (includes the built-in compensation for FlashType "Built-in,TTL&Comdr.")
+        Notes => q{
+            may be set even if flash does not fire.  Does not include the effect of
+            flash bracketing.
+        },
         ValueConv => 'my ($a,$b,$c)=unpack("c3",$val); $c ? $a*($b/$c) : 0',
         ValueConvInv => q{
@@ -738,12 +1199,22 @@
             },
         },
-        { #PH
+        { #IB
             Name => 'NRWData',
-            Condition => '$$valPt =~ /^NRW/', # starts with "NRW 0100"
-            Notes => 'large unknown block in NRW images, not copied to JPEG images',
-            # 'Drop' because not found in JPEG images (too large for APP1 anyway)
-            Flags => [ 'Unknown', 'Binary', 'Drop' ],
+            Condition => '$$valPt =~ /^NRW 0100/',
+            Drop => 1,  # 'Drop' because it is large and not found in JPEG images
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ColorBalanceB',
+            },
+        },
+        { #IB
+            Name => 'NRWData',
+            Condition => '$$valPt =~ /^NRW /',
+            Drop => 1,  # 'Drop' because it is large and not found in JPEG images
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ColorBalanceC',
+            },
         },
     ],
+    # 0x0015 - string[8]: "AUTO   "
     # D70 Image boundary?? top x,y bot-right x,y
     0x0016 => { #2
@@ -790,10 +1261,5 @@
         Writable => 'int16u',
         Count => 7,
-        PrintConv => q{
-            my @a = split ' ', $val;
-            return "Unknown ($val)" unless @a == 7;
-            $a[0] = $a[0] ? "On" : "Off";
-            return "$a[0] ($a[1]x$a[2] cropped to $a[3]x$a[4] at pixel $a[5],$a[6])";
-        }
+        PrintConv => \%cropHiSpeed,
     },
     0x001c => { #28 (D3 "the application of CSb6 to the selected metering mode")
@@ -811,4 +1277,6 @@
     0x001d => { #4
         Name => 'SerialNumber',
+        # Note: this has been known to change even if the serial number on the body
+        # stays the same if some parts of the camera were replaced by Nikon service
         Writable => 'string',
         Protected => 1,
@@ -849,14 +1317,41 @@
             5 => 'High',
             7 => 'Extra High', #10
+            8 => 'Extra High 1', #PH
+            9 => 'Extra High 2', #PH
+            10 => 'Extra High 3', #PH
+            11 => 'Extra High 4', #PH
             0xffff => 'Auto', #10
         },
     },
-    0x0023 => { #PH (D300, but also found in D3,D3S,D3X,D90,D300S,D700,D3000,D5000)
-        Name => 'PictureControlData',
-        Writable => 'undef',
-        Permanent => 0,
-        Binary => 1,
-        SubDirectory => { TagTable => 'Image::ExifTool::Nikon::PictureControl' },
-    },
+    0x0023 => [
+        { #PH (D300, but also found in D3,D3S,D3X,D90,D300S,D700,D3000,D5000)
+            Name => 'PictureControlData',
+            Condition => '$$valPt =~ /^01/',
+            Writable => 'undef',
+            Permanent => 0,
+            Flags => [ 'Binary', 'Protected' ],
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::PictureControl' },
+        },{ #28
+            Name => 'PictureControlData',
+            Condition => '$$valPt =~ /^02/',
+            Writable => 'undef',
+            Permanent => 0,
+            Flags => [ 'Binary', 'Protected' ],
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::PictureControl2' },
+        },{
+            Name => 'PictureControlData',
+            Condition => '$$valPt =~ /^03/',
+            Writable => 'undef',
+            Permanent => 0,
+            Flags => [ 'Binary', 'Protected' ],
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::PictureControl3' },
+        },{
+            Name => 'PictureControlData',
+            Writable => 'undef',
+            Permanent => 0,
+            Flags => [ 'Binary', 'Protected' ],
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::PictureControlUnknown' },
+        },
+    ],
     0x0024 => { #JD
         Name => 'WorldTime',
@@ -870,5 +1365,5 @@
         SubDirectory => {
             TagTable => 'Image::ExifTool::Nikon::ISOInfo',
-            ByteOrder => 'BigEndian', #(NC)
+            ByteOrder => 'BigEndian',
         },
     },
@@ -887,5 +1382,4 @@
         SubDirectory => {
             TagTable => 'Image::ExifTool::Nikon::DistortInfo',
-            ByteOrder => 'BigEndian', #(NC)
         },
     },
@@ -897,4 +1391,5 @@
         },
     },
+    # 0x2d - "512 0 0","512 3 10","512 1 14",...
     0x0032 => { #PH
         Name => 'UnknownInfo2',
@@ -903,4 +1398,60 @@
             ByteOrder => 'BigEndian', #(NC)
         },
+    },
+    0x0034 => { #forum9646
+        Name => 'ShutterMode',
+        Writable => 'int16u',
+        PrintConv => {
+             0 => 'Mechanical',
+             16 => 'Electronic',
+           # 33 => ? seen for 1J2
+             48 => 'Electronic Front Curtain',
+             64 => 'Electronic (Movie)', #JanSkoda (Z6II)
+             80 => 'Auto (Mechanical)', #JanSkoda (Z6II)
+             81 => 'Auto (Electronic Front Curtain)', #JanSkoda (Z6II)
+        },
+    },
+    0x0035 => { #32
+        Name => 'HDRInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Nikon::HDRInfo' },
+    },
+    0x0037 => { #XavierJubier
+        Name => 'MechanicalShutterCount',
+        Writable => 'int32u',
+    },
+    0x0039 => {
+        Name => 'LocationInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Nikon::LocationInfo' },
+    },
+    0x003d => { #IB
+        Name => 'BlackLevel',
+        Writable => 'int16u',
+        Count => 4,
+        # (may need to divide by 4 for some images, eg. D3300/D5300, 12 bit - ref IB)
+    },
+    0x003e => { #28
+        Name => 'ImageSizeRAW',
+        PrintConv => {
+             1 => 'Large',
+             2 => 'Medium',
+             3 => 'Small',
+        },
+    },
+    0x0045 => { #IB
+        Name => 'CropArea',
+        Notes => 'left, top, width, height',
+        Writable => 'int16u',
+        Count => 4,
+    },
+    0x004e => { #28
+        Name => 'NikonSettings',
+        Writable => 'undef',
+        Permanent => 0,
+        Flags => [ 'Binary', 'Protected' ],
+        SubDirectory => { TagTable => 'Image::ExifTool::NikonSettings::Main' },
+    },
+    0x004f => { #IB (D850)
+        Name => 'ColorTemperatureAuto',
+        Writable => 'int16u',
     },
     0x0080 => { Name => 'ImageAdjustment',  Writable => 'string' },
@@ -911,4 +1462,6 @@
         Writable => 'int8u',
         # credit to Tom Christiansen (ref 7) for figuring this out...
+        # (note that older models don't seem to set bits 4-7 (0xf0), so the
+        #  LensType may be different with different models, ref Kenneth Cochran)
         PrintConv => q[$_ = $val ? Image::ExifTool::DecodeBits($val,
             {
@@ -917,14 +1470,26 @@
                 2 => 'G',
                 3 => 'VR',
+                4 => '1', #PH
+                5 => 'FT-1', #PH/IB
+                6 => 'E', #PH (electromagnetic aperture mechanism)
+                7 => 'AF-P', #PH/IB
             }) : 'AF';
             # remove commas and change "D G" to just "G"
-            s/,//g; s/\bD G\b/G/; $_
+            s/,//g; s/\bD G\b/G/;
+            s/ E\b// and s/^(G )?/E /;      # put "E" at the start instead of "G"
+            s/ 1// and $_ = "1 $_";         # put "1" at start
+            s/FT-1 // and $_ .= ' FT-1';    # put "FT-1" at end
+            return $_;
         ],
         PrintConvInv => q[
             my $bits = 0;
-            $bits |= 0x01 if $val =~ /\bMF\b/i;
-            $bits |= 0x02 if $val =~ /\bD\b/i;
-            $bits |= 0x06 if $val =~ /\bG\b/i;
-            $bits |= 0x08 if $val =~ /\bVR\b/i;
+            $bits |= 0x01 if $val =~ /\bMF\b/i; # bit 0
+            $bits |= 0x02 if $val =~ /\bD\b/i;  # bit 1
+            $bits |= 0x06 if $val =~ /\bG\b/i;  # bits 1 and 2
+            $bits |= 0x08 if $val =~ /\bVR\b/i; # bit 3
+            $bits |= 0x10 if $val =~ /\b1\b/;   # bit 4
+            $bits |= 0x20 if $val =~ /\bFT-1/i; # bit 5
+            $bits |= 0x80 if $val =~ /\bAF-P/i; # bit 7 (not used by all models)
+            $bits |= 0x46 if $val =~ /\bE\b/i;  # bits 1, 2 and 6
             return $bits;
         ],
@@ -956,4 +1521,5 @@
             8 => 'Fired, Commander Mode',
             9 => 'Fired, TTL Mode',
+            18 => 'LED Light', #G.F. (movie LED light)
         },
     },
@@ -986,4 +1552,18 @@
         # slows down your drive operation to 50% (1.5fps max not 3fps).  But no
         # longer does !$val alone indicate single-frame operation. - TC, D70
+        # The following comments are from Warren Hatch:
+        # Bits 4,6,8 indicate bracketing mode.
+        #  - all 0's => Bracketing Off
+        #  - bit 4 on with bits 6,8 off => Exposure Bracketing On
+        #  - bits 4,6 on => WB bracketing On
+        #  - 4,8 on => ADL Bracketing On
+        # Bit 2 gives tethered status:  Off=>Not Tethered; On=Tethered.
+        #  - that this simply indicates a camera is connected via a cord to a PC
+        #    (doesn't necessarily mean that the shutter was tripped by the computer)
+        # Bits 0,1,3,7,9 relate to how the shutter is tripped in concert with the
+        #  Release Mode dial [although I cannot cause bit 7 to flip with any of my gear and
+        #  I suspect it is no longer used for the D500].  Regardless, the ReleaseMode tag
+        #  offers a superior decoding of this information for the D4s, D810 and D500.
+        # Bit 5 indicates whether or not AutoISO is enabled.
         PrintConv => q[
             $_ = '';
@@ -997,8 +1577,10 @@
                 1 => 'Delay',
                 2 => 'PC Control',
+                3 => 'Self-timer', #forum6281 (NC)
                 4 => 'Exposure Bracketing',
                 5 => $$self{Model}=~/D70\b/ ? 'Unused LE-NR Slowdown' : 'Auto ISO',
                 6 => 'White-Balance Bracketing',
                 7 => 'IR Control',
+                8 => 'D-Lighting Bracketing', #forum6281 (NC)
             });
         ],
@@ -1018,7 +1600,9 @@
     0x008c => {
         Name => 'ContrastCurve', #JD
-        Writable => 0,
-        Binary => 1,
-    },
+        Writable => 'undef',
+        Flags => [ 'Binary', 'Protected', 'Drop' ], # (drop because not found in Nikon JPEG's)
+    },
+    # ColorHue: MODE1/MODE1a=sRGB, MODE2=Adobe RGB, MODE3a=more saturated sRGB
+    # --> should really be called ColorSpace or ColorMode, but that would conflict with other tags
     0x008d => { Name => 'ColorHue' ,        Writable => 'string' }, #2
     # SceneMode takes on the following values: PORTRAIT, PARTY/INDOOR, NIGHT PORTRAIT,
@@ -1046,5 +1630,5 @@
                 TagTable => 'Image::ExifTool::Nikon::ShotInfoD80',
                 DecryptStart => 4,
-                DecryptLen => 764,
+                DecryptLen => 765,
                 # (Capture NX can change the makernote byte order, but this stays big-endian)
                 ByteOrder => 'BigEndian',
@@ -1097,5 +1681,5 @@
                 TagTable => 'Image::ExifTool::Nikon::ShotInfoD3S',
                 DecryptStart => 4,
-                DecryptLen => 0x2e6,
+                DecryptLen => 0x2e9,
                 ByteOrder => 'BigEndian',
             },
@@ -1134,4 +1718,5 @@
             },
         },
+        # 0225 - D600
         { #29 (D700 firmware version 1.02f)
             Condition => '$$valPt =~ /^0212/ and $count == 5312',
